<template>
  <div class="container mx-auto py-4 md:py-12 px-2 md:px-60">
    <my-header />
    <main>
      <p
        :class="{ hidden: !instancesCount }"
        class="text-center max-w-lg mt-6 mb-12 mx-auto dark:text-zinc-300"
        v-html="
          $ngettext(
            'Search for your favorite events and groups on %{tagStart}one Mobilizon website%{tagEnd} indexed by %{indexName}!',
            'Search for your favorite events and groups on %{tagStart}%{instancesCount} Mobilizon websites%{tagEnd} indexed by %{indexName}!',
            instancesCount,
            {
              tagStart,
              tagEnd,
              indexName,
              instancesCount: instancesCount.toString(),
            },
            true
          )
        "
      />

      <search-warning />

      <div class="flex flex-wrap items-center justify-center gap-3 md:gap-4">
        <category
          v-for="category in promotedCategories"
          :key="category.key"
          :category="category"
          :with-details="true"
        />
      </div>

      <div
        class="mx-auto w-full max-w-lg rounded-2xl dark:bg-gray-800 p-2 mt-10"
      >
        <Disclosure v-slot="{ open }">
          <DisclosureButton
            class="flex w-full justify-between rounded-lg px-4 py-2 text-left text-sm font-medium dark:text-zinc-300"
          >
            {{ $gettext('Category illustrations credits') }}
            <svg
              width="24"
              height="24"
              :class="open ? 'transform rotate-90' : ''"
              xmlns="http://www.w3.org/2000/svg"
              fill="none"
              viewBox="0 0 24 24"
              stroke="currentColor"
              strokeWidth="{2}"
            >
              <path
                strokeLinecap="round"
                strokeLinejoin="round"
                d="M9 5l7 7-7 7"
              />
            </svg>
          </DisclosureButton>
          <DisclosurePanel class="text-gray-500">
            <div class="flex flex-col dark:text-zinc-300 gap-2 py-4 px-1">
              <p
                v-for="(categoryLicence, key) in categoriesPicturesLicences"
                :key="key"
                class="flex flex-row gap-1 items-center"
              >
                <a
                  :href="categoryLicence.source.url"
                  target="_blank"
                  class="shrink-0"
                >
                  <picture class="brightness-50">
                    <source
                      :srcset="`/img/categories/${key.toLowerCase()}.jpg 2x, /img/categories/${key.toLowerCase()}.jpg`"
                      media="(min-width: 1000px)"
                    />
                    <source
                      :srcset="`/img/categories/${key.toLowerCase()}.jpg 2x, /img/categories/${key.toLowerCase()}-small.jpg`"
                      media="(min-width: 300px)"
                    />
                    <img
                      class="w-full h-12 w-12 object-cover"
                      :src="`/img/categories/${key.toLowerCase()}.jpg`"
                      :srcset="`/img/categories/${key.toLowerCase()}-small.jpg `"
                      alt=""
                    />
                  </picture>
                </a>
                <span
                  class="flex-0"
                  v-html="
                    $gettext(
                      'Illustration picture for “%{category}” by %{author} on %{source} (%{license})',
                      {
                        category: eventCategoryLabel(key, $gettext),
                        author: imageAuthor(categoryLicence.author),
                        source: imageSource(categoryLicence.source),
                        license: imageLicense(categoryLicence),
                      },
                      true
                    )
                  "
                />
              </p>
            </div>
          </DisclosurePanel>
        </Disclosure>
      </div>
    </main>
  </div>
</template>
<script lang="ts" setup>
  import { computed, inject } from 'vue'
  import SearchWarning from '../components/SearchWarning.vue'
  import MyHeader from '../components/Header.vue'
  import Category from '../components/Category.vue'
  import { CategoryStatsModel } from '../../../shared/stats.model'
  import {
    categoriesPicturesLicences,
    CategoryPictureLicencing,
    eventCategoryLabel,
  } from '@/query/constants'
  import { useGettext } from 'vue3-gettext'
  import { ServerConfig } from '../../../shared'

  import {
    Disclosure,
    DisclosureButton,
    DisclosurePanel,
  } from '@headlessui/vue'

  const categoryStats = inject<CategoryStatsModel[]>('categoryStats')

  const config = inject<ServerConfig>('config')

  const instancesCount = computed(() => config.indexedHostsCount)
  const indexName = computed(() => config.searchInstanceName)

  const { $gettext } = useGettext()

  const tagStart = computed(() => {
    return `<a class="underline" href="${config.indexedInstancesUrl}" target="_blank">`
  })
  const tagEnd = '</a>'
  const promotedCategories = computed((): CategoryStatsModel[] => {
    return categoryStats
      .filter(
        ({ key, doc_count }) =>
          key !== 'MEETING' &&
          doc_count >= 1 &&
          eventCategoryLabel(key, $gettext) !== undefined
      )
      .sort((a, b) =>
        eventCategoryLabel(a.key, $gettext).localeCompare(
          eventCategoryLabel(b.key, $gettext)
        )
      )
  })

  const imageAuthor = (author) =>
    `<a target="_blank" class="underline font-medium" href="${author?.url}">${author?.name}</a>`
  const imageSource = (source) =>
    `<a target="_blank" class="underline font-medium" href="${source?.url}">${source?.name}</a>`

  const imageLicense = (categoryLicence: CategoryPictureLicencing): string => {
    let license = categoryLicence?.license
    if (categoryLicence?.source?.name === 'Unsplash') {
      license = {
        name: 'Unsplash License',
        url: 'https://unsplash.com/license',
      }
    }
    return `<a target="_blank" class="underline font-medium" href="${license?.url}">${license?.name}</a>`
  }
</script>
